/*
 * Created on 23-03-2005
 * Para el ramo de Dise&ntilde;o y Programaci&oacute;n Orientada a Objetos - elo329
 * Universidad tecnica Federico Santa Maria
 * Departamento de Electronica
 * Profesor:Agust&iacute;n Gonz&aacute;lez
 * 
 */

/**
 * @author Miguel Rebolledo<br>
 * 
 * Esta clase tiene como objetivo utilizar y probar cada uno
 * de los metodos de la clase Vector, de manera de escribir
 * en pantalla el rasultado de cada operacioncomo faild o passed.<br>
 * Soluci&oacute;n a la tarea 1 del ramo de Dise&ntilde;o y Programaci&oacute;n Orientada a Objetos - elo329<br>
 * Universidad T&eacute;cnica Federico Santa Maria<br>
 * Departamento de Electr&oacute;nica<br>
 * Profesor:Agust&iacute;n Gonz&aacute;lez<br>
 * 
 * @version 1.0
 * 
 */
public class testVector 
{
	private static Vector a = new Vector(5D , 6D);
	private  static Vector b = new Vector(2D , 2D);

	public static void main(String[] args) 
	{
		
		System.out.print("\t ***********************************************\n" 
				+ "\t *               testVector.class              *\n" 
				+ "\t *        Miguel Angel Rebolledo Las Heras     *\n"
				+ "\t ***********************************************\n" );
/*				+ "\t    Vectores de Prueba \n");
		//Se imprimen los datos de los vectores de prueba
		
		System.out.println("  A =" + a.toString() + "\n  B =" + b.toString());
*/		
		//Se realiza el test con el metodo suma(a,b)
		testSuma();
		
		//Se realiza el test del metodo resta(a,b)
		testResta();
		
		//Se realiza el test del metodo sumale(b)
		testTraslacion();
		
		//Se realiza el test del metodo rotar(x)
		testRotar();
		
		//Se realiza el test del metodo productoPunto(a, b)
		testPunto();
		
		//Se realiza el test del metodo multiplicarPorEscalar(x)
		testEscalar();
	}
	/**
	 * Metodo para probar el metodo de la clase Vector suma(Vector a, Vector b)
	 *
	 */
	static void  testSuma()
	{
		Vector c = Vector.suma(a, b);
		System.out.print("\nEjecutando Vector.suma(["+(float)a.X+","+(float)a.Y+"],["+(float)b.X+","+(float)b.Y+"])\n");
		
		//Se  imprime el resultado del vector C
		System.out.println(c.toString());
		//Se comprueba si Vector C = Vector a + Vector b por componentes individuales
		
		if ((c.X == (a.X + b.X)) && (c.Y == (a.Y + b.Y)))
			System.out.println("............test passed ;-D \n");
		else
			System.out.println("............test failed :-( \n");
		
	}
	
	/**
	 * Metodo para probar el metodo de la clase Vector resta(Vector a, Vector b) 
	 *
	 */
	static void testResta()
	{
		//Se crea el vector d que se crea con el metodo resta()
		Vector d = Vector.resta(a, b);
		System.out.println("Ejecutando Vector.resta(["+(float)a.X+","+(float)a.Y+"],["+(float)b.X+","+(float)b.Y+"])");
		
		//Se imprime el resultado del vector D
		
		System.out.println(d.toString());
		
		//Se comprueba si Vector d = Vector a -Vector b por cada componente
		
		if ((d.X == (a.X - b.X)) && (d.Y == (a.Y - b.Y)))
			System.out.println("............test passed ;-D \n");
		else
			System.out.println("............test failed :-( \n");

	}
	
	/**
	 *Metodo para probar el metodo de la clase Vector sumale(Vector a) 
	 *
	 */
	static void testTraslacion()
	{
		//Se crea el vector (5,9)
		Vector e = new Vector(5D, 9D);
		
		//se imprime en pantalla que prueba se realizara y con que argumentos
		System.out.println("Ejecutando ["+(float)e.X+","+(float)e.Y+"].sumale(["+(float)b.X+","+(float)b.Y+"])");
		
		//Se utiliza el metodo sumarle() a nuestro vector creado el vectro b
		// Vector e = vector e + Vector b
		e.sumarle(b);
		
		//Se imprime el resultado de la operacion
		System.out.println( e.toString());
		
		//Se comprueba si ambas componentes sumadas individualmente son iguales al resultado
		if ((e.X == 5 + b.X) && (e.Y == 9 + b.Y))
			System.out.println("............test passed ;-D \n");
		else
			System.out.println("............test failed :-( \n");

	}
	
	/**
	 * Metodo para probar el metodo de la clase Vector rotar(x radians)
	 *
	 */
	static void testRotar()
	{
		//Se crea el factor en radianes para rotar el vector
		float alfa = 0.5F; 
		
		//Se almacenan en variables locales los datos iniciales del vector a rotar
		final double magnitudInicial = a.calculaMagnitud();
		final double anguloInicial = a.calculaAngulo();
		
		//Se imprime en pantalla los argumentos de la prueba a realizar
		System.out.println("Ejecutando ["+(float)a.X+","+(float)a.Y+"].rotar("+alfa+" radians)");

		//Se llama al metodo que realiza la operacion
		a.rotar(alfa);
		
		//Se imprime en pantalla el resultado del vector una vez rotado
		System.out.println(a.toString());
		
		//Se verifica si la magnitud del vector se conservo despues de la rotacion
		//Se verifica si la suma de los angulos es lineal una vez conseguidos los nuevos puntos del vector
		if((a.calculaMagnitud()== magnitudInicial) || (Math.sqrt((double)a.calculaAngulo())== Math.sqrt(((double)a.calculaAngulo()+(double)alfa))))
			System.out.println("............test passed ;-D \n");
		else
			System.out.println("............test failed :-( \n");

	}
	/**
	 * Metodo para probar el metodo de la clase Vector productoPunto(Vector a, Vector b)
	 *
	 */
	static void testPunto()
	{
		//Se imprime el metodo a utilizar y los argumentos que influyen en la prueba
		System.out.println("Ejecutando productoPunto(["+(float)a.X+","+(float)a.Y+"],["+(float)b.X+","+(float)b.Y+"])");
		
		//Se imprime el resultado de la operacion 
		System.out.println("\t\t Resultado = " + Vector.productoPunto(a, b));
		
		//Se comprueba si se cumple la siguiente relacion
		//Si |B|cos(anguloA-anguloB)== productoPunto(A,B)/|A| test aprobado
		if ((b.calculaMagnitud() * Math.cos(a.calculaAngulo() - b.calculaAngulo())) == (Vector.productoPunto(a, b) / a.calculaMagnitud()))
			System.out.println("............test passed ;-D \n");
		else
			System.out.println("............test failed :-( \n");

	}
	/**
	 * Metodo para probar el metodo de la clase Vector multiplicarPorEscalar(x) 
	 *
	 */
	static void testEscalar()
	{
		//Se inician las variables que influiran en el test
		double x = 10, y = 11;
		float mult = 6;
		
		//Se crea el vector de prueba g
		Vector g = new Vector(x, y);
		
		//Se imprime en pantalla el metodo a utilizar y los argumentos que utilizara
		System.out.println("Ejecutando ["+g.X+","+g.Y+"].multiplicarPorEscalar(6)");
		
		//Se llama al metodo a probar
		g.multiplicacionPorEscalar(mult);
		
		//Se imprime el resultado de la operacion en la pantalla
		System.out.println(g.toString());
		
		//Se comprueba si lo que se realizo corresponde a una multiplicacion lineal
		//de los terminos que influyeron con los entregados por el metodo 
		if ((g.X == (float)(x * mult)) && (g.Y == (float)(y * mult)))
			System.out.println("............test passed ;-D \n");
		else
			System.out.println("............test failed :-( \n");

	}
	
}
